<?php

namespace Proxies;

/**
 * THIS CLASS WAS GENERATED BY THE DOCTRINE ORM. DO NOT EDIT THIS FILE.
 */
class EntitiesColumnProxy extends \Entities\Column implements \Doctrine\ORM\Proxy\Proxy
{
    private $_entityPersister;
    private $_identifier;
    public $__isInitialized__ = false;
    public function __construct($entityPersister, $identifier)
    {
        $this->_entityPersister = $entityPersister;
        $this->_identifier = $identifier;
    }
    /** @private */
    public function __load()
    {
        if (!$this->__isInitialized__ && $this->_entityPersister) {
            $this->__isInitialized__ = true;
            if ($this->_entityPersister->load($this->_identifier, $this) === null) {
                throw new \Doctrine\ORM\EntityNotFoundException();
            }
            unset($this->_entityPersister, $this->_identifier);
        }
    }
    
    
    public function id($id = '@NULL')
    {
        $this->__load();
        return parent::id($id);
    }

    public function idx($idx = '@NULL')
    {
        $this->__load();
        return parent::idx($idx);
    }

    public function variable($var = '@NULL')
    {
        $this->__load();
        return parent::variable($var);
    }

    public function caption($caption = '@NULL')
    {
        $this->__load();
        return parent::caption($caption);
    }

    public function type($type = '@NULL')
    {
        $this->__load();
        return parent::type($type);
    }

    public function expression($expression = '@NULL')
    {
        $this->__load();
        return parent::expression($expression);
    }

    public function defaultValue($defaultValue = '@NULL')
    {
        $this->__load();
        return parent::defaultValue($defaultValue);
    }

    public function validRange($validRange = '@NULL')
    {
        $this->__load();
        return parent::validRange($validRange);
    }

    public function validRegex($validRegex = '@NULL')
    {
        $this->__load();
        return parent::validRegex($validRegex);
    }

    public function validValues($validValues = '@NULL')
    {
        $this->__load();
        return parent::validValues($validValues);
    }

    public function isValid($value)
    {
        $this->__load();
        return parent::isValid($value);
    }

    public function part(\Entities\Part $part = NULL)
    {
        $this->__load();
        return parent::part($part);
    }


    public function __sleep()
    {
        return array('__isInitialized__', 'id', 'idx', 'variable', 'caption', 'type', 'expression', 'defaultValue', 'validRange', 'validRegex', 'validValues', 'part');
    }

    public function __clone()
    {
        if (!$this->__isInitialized__ && $this->_entityPersister) {
            $this->__isInitialized__ = true;
            $class = $this->_entityPersister->getClassMetadata();
            $original = $this->_entityPersister->load($this->_identifier);
            if ($original === null) {
                throw new \Doctrine\ORM\EntityNotFoundException();
            }
            foreach ($class->reflFields AS $field => $reflProperty) {
                $reflProperty->setValue($this, $reflProperty->getValue($original));
            }
            unset($this->_entityPersister, $this->_identifier);
        }
        
    }
}